#sccs	"@(#)adminbin:Instcpio.sh	1.2"

# -------------------------------------------------------------------------
#                                                                Instcpio.sh
# PURPOSE:  Install application software which resides in cpio files
#		- these files are defined in Suffixes with suffix "+IN"
# CALLED BY: Click on a file with the "+IN" suffix
# REQUIRED FILES: /etc/iv,
# -------------------------------------------------------------------------

GOOD=""
CONTENTS=/usr/installed/CONTENTS
INDIR=/usr/installed
SOURCEDIR=/usr/spool/uucppublic
STARTDIR=`pwd`
TERMCAP=
export TERMCAP
umask 022

ARG="$1"
rm -rf /tmp/installed
mkdir /tmp/installed
cd /tmp/installed

while true
do

# -----------------------------------------


newwind

#  This is the stuff that takes the correct cpio file and moves it
#  If there is an argument to Instcpio.sh, then it is taken as the
#   installable cpio file, otherwise it looks in the directory $SOURCEDIR

#   At the present time, any execution from the UA will provide an argument


if [ -z "$ARG" ]
then
	if [ ! -d $SOURCEDIR ]
		then
		message -cu "There are no installable files stored in the public folder.  If the source of the files is electronic mail, check with the sender to insure correct addressing."
		exit
		fi
	cd $SOURCEDIR
	
	TEM=`ls`
		if [ -z "$TEM" ]
		then
		message -cu "There are no installable files stored in the public folder.  If the source of the files is electronic mail, check with the sender to insure correct addressing."
		exit
		fi
	
	cat <<END
	
	The following installable software packages are
	available in a public file folder:
	
	`ls *+IN | sed s/+IN//gp `
	
END
	while true
		do
		echo "Please type one of these names and touch Return:\c"
		read FILENAME
		FILENAME=${SOURCEDIR}/${FILENAME}+IN
		if [ -f "$FILENAME" ]
		then
		break
		else 
		message "You have not entered the file name correctly.  Please retype one of the valid choices.\n\n"
		fi
		done
else
	FILENAME=${STARTDIR}/$ARG
fi


cd /tmp/installed
		clear
# ~~~~~~~~~~~~~~~~~~~~~~~~~~
#  LOCAL MODIFICATION - CHECK FOR SIZE HERE RATHER THAN THE SINGLE FLOPPY CHECK

#  Check to see if there is room to un-cpio the file


	NUMBER=` ls -s $FILENAME | awk ' { print $1 } ' `
	set `df -f /`
	FREE=$3
	if [  `expr $NUMBER \> $FREE` = "1" ] 
	then
		message -iu "There is insufficient space left on your system.  Please remove some files and try again.\n\nPress Enter to continue."
		break
	fi


# ~~~~~~~~~~~~~~~~~~~~~~~~~~
		echo "\n\n\n\n\n\n                     Preparing for installation\n\n\n\n\n\n"
		cpio  -icBdu < $FILENAME 2>/tmp/cplog$$
		err=$?
		if [ "`grep \"Out of phase\" /tmp/cplog$$`" ]
		then
			clear
			message -cu "The file you are trying to install cannot be used.  Please arrange for another copy."
			if [ $? != "0" ]
			then break
			fi
		elif [ "`grep \"annot create\" /tmp/cplog$$`" ]
		then
			clear
			message -u "Your system is out of space.  Please remove some files and try again."
			break
		elif [ "$err" != "0" ] 
		then
			clear
			message -cu "The file you are trying to install cannot be used.  Please arrange for another copy."
			if [ $? != "0" ]
			then break
			fi
		elif [ -f ./Install ]
		then
			if [ -f "Name" ]
			then
				NAME=`cat -s Name`
				FNAME=`date '+%y%m%d' `$$
				echo $FNAME $NAME >> $CONTENTS
				if [ -r ./Remove ]
				then 
# ---------------------------------

cat <<END

		The installable file has
		been processed.  You are
		now ready to proceed with 
		the actual installation.


But First you have the option of creating an installable
	floppy disk with this software on it.

You will need a formatted disk if you choose to create 
	a backup floppy disk.
END
echo "Do you want to create a backup disk (y or n)?\c"
read ANS
if [ "$ANS" = 'y' ]
then

#   CREATING BACKUP DISK FROM CONTENTS OF /tmp/installed

# +++++++++++++++++++++++ FLOPPY CHECKER


clear
	message -c "Insert floppy to be used for installable package.  The floppy MUST be formatted.  If you do not have any formatted floppy disks, please hit Cancel."
# We have prompted user to insert floppy
if [ $? = "0" ] 
then
# determine whether it's formatted
while true 
do
	FLOP=`iv -t /dev/rfp020 2>/dev/null | grep Partition`
	if [ "$?" != "0" ] 
	then
		clear
		message -c "Cannot copy to the floppy disk.  Possible reasons include: disk is not inserted or is inserted improperly; latch is not closed. Please check the floppy disk and we'll try again."
		if [ $? != "0" ] ; then break ; fi
	continue
	else
		set $FLOP ; FLOP1=$1
		if test $FLOP1 != Partition
		then
			clear
			message -c "Floppy is not formatted.  Please use a formatted floppy disk and try again."
			if [ $? != "0" ] 
			then
				dismount -f > /dev/null 2>&1
				break 2
			fi
			dismount -f > /dev/null 2>&1
		fi

		clear
		echo "          Creation of Floppy in progress\n\n\n\n\n\n"
find . -print | cpio -ocB > /dev/rfp021 2>/dev/null

if [ "$?" != "0" ] 
then
				dismount -f > /dev/null 2>&1
	clear
	if [ $? != "0" ]
	then break
	fi
else
break
	fi
fi
done
fi


# +++++++++++++++++++++++ END FLOPPY CHECKER

else
echo "\n\n      O.K. - no backup will be created.\n\n\n"
fi


# ------------------------------

					mv ./Remove ${INDIR}/${FNAME}.un
					clear
					chmod +x ./Install
					./Install
					ERR=$?
					if [ $? != 64 ]
					then	GOOD="yes"
					fi
#  add item to Uninstall.menu 
					if [ ! "`grep \"^Name=$NAME$\" $UA/Uninstall.menu`" ]
					then 
						echo "Name="$NAME >>$UA/Uninstall.menu
						echo "Name="$NAME >>$UA/Showsoft.menu
					fi
					clear
					message -iu "The installation of the $NAME package is now complete.\n\nPlease press Enter to continue."
					I=`ps -e | grep ua | cut -c1-6`
					for i in $I
					do
						kill -16 $i
					done
					break
				else
					clear
					message -cu "The installable file is missing the 'Remove' program.\nYou will need to use a properly constructed installable file.\nAborting the installation."
					if [ $? != "0" ]
					then break
					fi
				fi
			else
				clear
					message -cu "The installable file is missing the 'Name' program.\nYou will need to use a properly constructed installable file.\nAborting the installation."
				if [ $? != "0" ]
				then break
				fi
			fi
		else
			clear
					message -cu "The installable file is missing the 'Install' program.\nYou will need to use a properly constructed installable file.\nAborting the installation."
			if [ $? != "0" ]
			then break
			fi
		fi
clear
done
cd /tmp
rm -rf /tmp/installed /tmp/cplog$$
if [ "$GOOD" ]
then
rm $FILENAME
fi

# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                  Instcpio.sh
# =========================================================================
