#sccs	"@(#)adminbin:RSfree.sh	1.3"
# -------------------------------------------------------------------------
#                                                                 RSfree.sh
# PURPOSE: Remove currently configured device from an RS232 port
#	   This program can be invoked two ways:
#		RSfree.sh TTY        (TTY must be one of 000 through 006)
#		RSfree.sh TTY noconfirm
# CALLED BY: /usr/lib/ua/RS232 object file
# MODIFIED FILES: /etc/.rs232, /etc/.rs232_$TTY, /usr/lib/uucp/L-devices
# -------------------------------------------------------------------------

ERROR3a="The RS232 Port is currently connected to a "
ERROR4=".\nAre you sure you want to remove it?"

TERMCAP=
export TERMCAP
umask 022

TTY=$1
CONF=$2

# get the data from /etc/.rs232 or /etc/.rs232_TTY

if [ $TTY = "000" ]
then
	if [ -s /etc/.rs232 ]
	then
		. /etc/.rs232
	else
		TYPE="NONE"
	fi
elif [ -s /etc/.rs232_$TTY ]
then
	. /etc/.rs232_$TTY
else
	TYPE="NONE"
fi

PTYPE="$TYPE"
if [ "$TYPE" = "OTHER" ]
then TYPE=$NAME
elif [ -z "$TYPE" ]
then TYPE="unknown device"
elif [ \( "$TYPE" = "NONE" \) -a \( -z "$CONF" \) ]
then
	message -i The RS232 port is free.\\nPress Enter to continue
	if [ "$?" != "0" ]
	then 
		exit 1
	fi
else
	if [ -z "$CONF" ]
	then
		message -c $ERROR3a ${TYPE}$ERROR4
		if [ "$?" != "0" ]
		then 
			exit 1
		fi
	fi
fi

if [ -f /usr/spool/uucp/LCK..tty{$TTY} ]
then
	message -i "Sorry, the RS232 port is being used right now.\n  Please try again later."
	exit 1
fi
#   Turning port off in case it was on.  No harm if it wasn't
getoff.sh $TTY
if [ "$?" = "0" ]
then
	message -i "Sorry, the RS232 port is being used right now.\n  Please try again later."
	exit 1
fi

case $PTYPE in
# Executable code for the "enter" option follows here

	MODEM)
	grep -v "$TTY" /usr/lib/uucp/L-devices > /tmp/L-dev$$
	mv /tmp/L-dev$$ /usr/lib/uucp/L-devices
	;;

	OTHER)
	grep -v "$TTY" /usr/lib/uucp/L-devices > /tmp/L-dev$$
	mv /tmp/L-dev$$ /usr/lib/uucp/L-devices
	;;

	COMPUTER)
	grep -v "$TTY" /usr/lib/uucp/L-devices > /tmp/L-dev$$
	mv /tmp/L-dev$$ /usr/lib/uucp/L-devices
	;;

	PRINTER)
message -i "Removing printer\nPlease stand by ..." &
mpid=$!
/usr/lib/lpshut > /dev/null 2>&1
/usr/lib/lpadmin -x${NAME} 2> /dev/null
/usr/lib/lpadmin -x${NAME}_R 2> /dev/null
/usr/lib/lpsched 2> /dev/null
kill $mpid > /dev/null 2>&1
	;;

	*)
	;;

# End of main case 
esac
if [ "$TTY" = "000" ]
then
	echo "TYPE='NONE'" > /etc/.rs232
else
	echo "TYPE='NONE'" > /etc/.rs232_$TTY
fi

# Turn Hardware Flow Control off in case it was on.  No harm if it wasn't.
rm -f /etc/daemons/tty$TTY.init
#Directory removed only if empty else error will be ignored.
rmdir /etc/daemons >/dev/null 2>&1
/etc/hfc_ctl -/dev/tty$TTY

# -------------------------------------------------------------------------
#  EXECUTABLE PROGRAM ENDS HERE                                   RSfree.sh
# =========================================================================
