#sccs	"@(#)uts/kern/sys:dialer.h	1.1"
/*
-----------------------------------------------------------------
|  The following declarations are used for forming the control  |
|  word for the dialer chip.  The low byte is used for tone     |
|  generation, high byte for the path and output control.       |
-----------------------------------------------------------------
*/

/*  DTMF tone values  */

#define	kDIGIT1 0x0000
#define	kDIGIT2 0x0008
#define	kDIGIT3 0x0004
#define	kDIGIT4 0x0001
#define	kDIGIT5 0x0009
#define	kDIGIT6 0x0005
#define	kDIGIT7 0x0002
#define	kDIGIT8 0x000A
#define	kDIGIT9 0x0006
#define	kDIGIT0 0x000B

#define kDIGAST 0x0003
#define kDIGPND 0x0007


/*  Touch tone volume control  */
/*  If kNoFeedback is used touch tone is not heard by the user  */

#define kTouchToneOff	0x0000  /* Dialing not possible! */
#define kNoTTFeedback	0x0030
#define kLoudTTVolume	0x0080  /* Feedback volume control  */
#define kNormalTTVolume	0x0040
#define kSoftTTVolume	0x00C0

/*  Ringer volume control  */

#define kLoudRinging	0x00B0
#define kNormalRinging	0x0070
#define kSoftRinging	0x00F0

/*  Speaker phone control  */

#define kTTtoLine	0x0930
#define kOnSpeaker	0x0A00
#define kOffSpeaker	0x0800
#define kCallProg	0x1000
#define kNoSpeakerPhone	0x1700
#define kHandset	0x2900
#define kNoHandset	0x0900

#define kOpenCircuit	0x4000
#define kCloseCircuit	(~kOpenCircuit)

#define OPENRELAY	0x4000
#define CLOSERELAY	(~OPENRELAY)
#define DIS_HNDSET	0x0000
#define ENB_HNDSET	(~DIS_HNDSET)
#define HOLDLINE	0x4000
#define UNHOLDLINE	(~HOLDLINE)
 
#define LN1_CONNECT	0x4000
#define	LN2_CONNECT	0x0000

#define RNGON		0x0
#define RNGOFF		0x1


/*  Telephony relay addresses  */

#define DIALER_LOWER	((unsigned char*) 0x4B0400)	/* dialer address   */
#define DIALER_HIGHER	((unsigned char*) 0x4B0800)	/* dialer address   */

#define HNDSET_RELAY	((unsigned short*) 0x490000)	/* Handset relay     */
#define LINE_SELECT	((unsigned short*) 0x491000) 	/* 0  */
#define HOOK1_RELAY	((unsigned short*) 0x492000)	/* line 1 hook relay */
#define HOOK2_RELAY	((unsigned short*) 0x493000)	/* line 2 hook relay */
#define LINE1_ACTIVE	((unsigned short*) 0x494000)	/* line 1 on hold    */
#define LINE2_ACTIVE	((unsigned short*) 0x495000)	/* line 2 on hold    */
#define A_LEAD1_RELAY	((unsigned short*) 0x496000)	/* line 1 A-lead     */
#define A_LEAD2_RELAY	((unsigned short*) 0x497000)	/* line 2 A-lead     */


#define OFFHOOK		0
#define ONHOOK		1

/*   These values are used to enabled the detection of external event	*/
/*   They are used to mask the word variable EventMaskReg.		*/

#define ENB_FAST_CLK	0x100
#define ENB_DSR_DETEC	0x080
#define ENB_RS232_RING	0x040
#define ENB_LPR_INT	0x020
#define ENB_MSG_WAIT	0x010
#define ENB_HOOK_DETEC	0x008
#define ENB_LN1_RING	0x004
#define ENB_LN2_RING	0x001


