/**********************************************************\
* Bugs : a bit-mapped arcade game for the AT&T UNIX PC.    *
*                                                          *
* By : Hans Jespersen                                      *
*                                                          *
\**********************************************************/

#include "rocks.h"

defsprites()
{
	int i;

	/* define large */

        rock[LARGE][0] = rock[LARGE][1] = rock[LARGE][2] = rock[LARGE][3] = 0xffff;
	for ( i = 4; i < 188; i += 4 ){
		rock[LARGE][i] = 0x0001;
		rock[LARGE][i+1] = 0x0000;
		rock[LARGE][i+2] = 0x0000;
		rock[LARGE][i+3] = 0x8000;
	}
        rock[LARGE][188] = rock[LARGE][189] = rock[LARGE][190] = rock[LARGE][191] = 0xffff;

	/* define medium */

        rock[MEDIUM][0] = rock[MEDIUM][1] = 0xffff;
	rock[MEDIUM][2] = rock[MEDIUM][3] = 0x0000;
	for ( i = 4; i < 92 ; i += 4 ){
		rock[MEDIUM][i] = 0x0001;
		rock[MEDIUM][i+1] = 0x8000;
		rock[MEDIUM][i+2] = 0x0000;
		rock[MEDIUM][i+3] = 0x0000;
	}
        rock[MEDIUM][92] = rock[MEDIUM][93] = 0xffff;

	/* define small */

        rock[SMALL][0] = 0xffff;
	rock[SMALL][1] = rock[SMALL][2] = rock[SMALL][3] = 0x0000;
	for ( i = 4; i < 44 ; i += 4 ){
		rock[SMALL][i] = 0x8001;
		rock[SMALL][i+1] = 0x0000;
		rock[SMALL][i+2] = 0x0000;
		rock[SMALL][i+3] = 0x0000;
	}
        rock[SMALL][44] = 0xffff;

	debris[0][0] = 0x0100;		/*	---- ---# ---- ----	*/
	debris[0][1] = 0x0100;		/*	---- ---# ---- ----	*/
	debris[0][2] = 0x0080;		/*	---- ---- #--- ----	*/
	debris[0][3] = 0x0080;		/*	---- ---- #--- ----	*/
	debris[0][4] = 0x0040;		/*	---- ---- -#-- ---- 	*/
	debris[0][5] = 0x0040;		/* 	---- ---- -#-- ----	*/
	debris[0][6] = 0x0020;		/*	---- ---- --#- ----	*/
	debris[0][7] = 0x0020;		/*	---- ---- --#- ----	*/
	debris[0][8] = 0x0010;		/*	---- ---- ---# ----	*/
	debris[0][9] = 0x0010;		/*	---- ---- ---# ----	*/
	debris[0][10] = 0x0008;		/*	---- ---- ---- #---	*/
	debris[0][11] = 0x0000;		/*	---- ---- ---- ----	*/

	debris[1][0] = 0x0100;		/*	---- ---# ---- ----	*/
	debris[1][1] = 0x0100;		/*	---- ---# ---- ----	*/
	debris[1][2] = 0x0200;		/*	---- --#- ---- ----	*/
	debris[1][3] = 0x0200;		/*	---- --#- ---- ----	*/
	debris[1][4] = 0x0400;		/*	---- -#-- ---- ---- 	*/
	debris[1][5] = 0x0400;		/* 	---- -#-- ---- ----	*/
	debris[1][6] = 0x0800;		/*	---- #--- ---- ----	*/
	debris[1][7] = 0x0800;		/*	---- #--- ---- ----	*/
	debris[1][8] = 0x1000;		/*	---# ---- ---- ----	*/
	debris[1][9] = 0x1000;		/*	---# ---- ---- ----	*/
	debris[1][10] = 0x2000;		/*	--#- ---- ---- ----	*/
	debris[1][11] = 0x0000;		/*	---- ---- ---- ----	*/

	debris[2][0] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][1] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][2] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][3] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][4] = 0x0000;		/*	---- ---- ---- ---- 	*/
	debris[2][5] = 0x0000;		/* 	---- ---- ---- ----	*/
	debris[2][6] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][7] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][8] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][9] = 0x0000;		/*	---- ---- ---- ----	*/
	debris[2][10] = 0x3ff8;		/*	--## #### #### #---	*/
	debris[2][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[0][0] = 0x0100;		/*	---- ---# ---- ----	*/
	ship[0][1] = 0x0100;		/*	---- ---# ---- ----	*/
	ship[0][2] = 0x0380;		/*	---- --## #--- ----	*/
	ship[0][3] = 0x0380;		/*	---- --## #--- ----	*/
	ship[0][4] = 0x07c0;		/*	---- -### ##-- ---- 	*/
	ship[0][5] = 0x07c0;		/* 	---- -### ##-- ----	*/
	ship[0][6] = 0x0fe0;		/*	---- #### ###- ----	*/
	ship[0][7] = 0x0fe0;		/*	---- #### ###- ----	*/
	ship[0][8] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[0][9] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[0][10] = 0x3ff8;		/*	--## #### #### #---	*/
	ship[0][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[1][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[1][1] = 0xc000;		/*	##-- ---- ---- ---- 	*/
	ship[1][2] = 0x7000;		/*	-### ---- ---- ----	*/
	ship[1][3] = 0x7c00;		/*	-### ##-- ---- ----	*/
	ship[1][4] = 0x3f00;		/*	--## #### ---- ----	*/
	ship[1][5] = 0x3fc0;		/*	--## #### ##-- ----	*/
	ship[1][6] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[1][7] = 0x1fc0;		/*	---# #### ##-- ----	*/
	ship[1][8] = 0x0f00;		/*	---- #### ---- ----	*/
	ship[1][9] = 0x0c00;		/*	---- ##-- ---- ----	*/
	ship[1][10] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[1][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[2][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[2][1] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[2][2] = 0x0004;		/*	---- ---- ---- -#--	*/
	ship[2][3] = 0x001c;		/*	---- ---- ---# ##--	*/
	ship[2][4] = 0x00fc;		/*	---- ---- #### ##--	*/
	ship[2][5] = 0x07fc;		/*	---- -### #### ##--	*/
	ship[2][6] = 0x3ffc;		/*	--## #### #### ##--	*/
	ship[2][7] = 0x07fc;		/*	---- -### #### ##--	*/
	ship[2][8] = 0x00fc;		/*	---- ---- #### ##--	*/
	ship[2][9] = 0x001c;		/*	---- ---- ---# ##--	*/
	ship[2][10] = 0x0004;		/*	---- ---- ---- -#--	*/
	ship[2][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[3][0] = 0x0000;		/*	---- ---- ---- ---- 	*/
	ship[3][1] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[3][2] = 0x0c00;		/*	---- ##-- ---- ----	*/
	ship[3][3] = 0x0f00;		/*	---- #### ---- ---- 	*/
	ship[3][4] = 0x1fc0;		/*	---# #### ##-- ----	*/
	ship[3][5] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[3][6] = 0x3fc0;		/*	--## #### ##-- ----	*/
	ship[3][7] = 0x3f00;		/*	--## #### ---- ----	*/
	ship[3][8] = 0x7c00;		/*	-### ##-- ---- ----	*/
	ship[3][9] = 0x7000;		/*	-### ---- ---- ----	*/
	ship[3][10] = 0xc000;		/*	##-- ---- ---- ----	*/
	ship[3][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[4][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[4][1] = 0x3ff8;		/*	--## #### #### #---	*/
	ship[4][2] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[4][3] = 0x1ff0;		/*	---# #### #### ----	*/
	ship[4][4] = 0x0fe0;		/*	---- #### ###- ----	*/
	ship[4][5] = 0x0fe0;		/*	---- #### ###- ----	*/
	ship[4][6] = 0x07c0;		/*	---- -### ##-- ----	*/
	ship[4][7] = 0x07c0;		/*	---- -### ##-- ----	*/
	ship[4][8] = 0x0380;		/*	---- --## #--- ----	*/
	ship[4][9] = 0x0380;		/*	---- --## #--- ----	*/
	ship[4][10] = 0x0100;		/*	---- ---# ---- ----	*/
	ship[4][11] = 0x0100;		/*	---- ---# ---- ----	*/

	ship[5][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[5][1] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[5][2] = 0x0030;		/*	---- ---- --## ----	*/
	ship[5][3] = 0x00f0;		/*	---- ---- #### ----	*/
	ship[5][4] = 0x03f8;		/*	---- --## #### #---	*/
	ship[5][5] = 0x0ff8;		/*	---- #### #### #---	*/
	ship[5][6] = 0x03fc;		/*	---- --## #### ##--	*/
	ship[5][7] = 0x00fc;		/*	---- ---- #### ##--	*/
	ship[5][8] = 0x003e;		/*	---- ---- --## ###-	*/
	ship[5][9] = 0x000e;		/*	---- ---- ---- ###-	*/
	ship[5][10] = 0x0003;		/*	---- ---- ---- --##	*/
	ship[5][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[6][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[6][1] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[6][2] = 0x2000;		/*	--#- ---- ---- ----	*/
	ship[6][3] = 0x3800;		/*	--## #--- ---- ----	*/
	ship[6][4] = 0x3f00;		/*	--## #### ---- ----	*/
	ship[6][5] = 0x3fe0;		/*	--## #### ###- ----	*/
	ship[6][6] = 0x3ffc;		/*	--## #### #### ##--	*/
	ship[6][7] = 0x3fe0;		/*	--## #### ###- ----	*/
	ship[6][8] = 0x3f00;		/*	--## #### ---- ----	*/
	ship[6][9] = 0x3800;		/*	--## #--- ---- ----	*/
	ship[6][10] = 0x2000;		/*	--#- ---- ---- ----	*/
	ship[6][11] = 0x0000;		/*	---- ---- ---- ----	*/

	ship[7][0] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[7][1] = 0x0003;		/*	---- ---- ---- --##	*/
	ship[7][2] = 0x000e;		/*	---- ---- ---- ###-	*/
	ship[7][3] = 0x003e;		/*	---- ---- --## ###-	*/
	ship[7][4] = 0x00fc;		/*	---- ---- #### ##--	*/
	ship[7][5] = 0x03fc;		/*	---- --## #### ##--	*/
	ship[7][6] = 0x0ff8;		/*	---- #### #### #---	*/
	ship[7][7] = 0x03f8;		/*	---- --## #### #---	*/
	ship[7][8] = 0x00f0;		/*	---- ---- #### ----	*/
	ship[7][9] = 0x0030;		/*	---- ---- --## ----	*/
	ship[7][10] = 0x0000;		/*	---- ---- ---- ----	*/
	ship[7][11] = 0x0000;		/*	---- ---- ---- ----	*/

	shot[0] = 0x0001;		/*	---- ---- ---- ---#	*/
	shot[1] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[2] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[3] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[4] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[5] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[6] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[7] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[8] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[9] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[10] = 0x0000;		/*	---- ---- ---- ----	*/
	shot[11] = 0x0000;		/*	---- ---- ---- ----	*/
}
